#ifndef MAG
#define MAG

#include <Wire.h>
#include <SPI.h>

#define MG_DEVICE_ADDRESS       0x1E
#define MG_MASK_READ            0x01
#define MG_MASK_WRITE           0x00
#define MG_REGISTER_A           0x00
#define MG_REGISTER_B           0x01
#define MG_REGISTER_MODE        0x02
#define MG_REGISTER_X_MSB       0x03
#define MG_REGISTER_X_LSB       0x04
#define MG_REGISTER_Z_MSB       0x05
#define MG_REGISTER_Z_LSB       0x06
#define MG_REGISTER_Y_MSB       0x07
#define MG_REGISTER_Y_LSB       0x08

#define MY_DECLANATION_ANGLE    0
#define GAUSS_TO_MICROTESLA     (100)
#define MG_GAUSS_XY             1100.0F
#define MG_GAUSS_Z              980.0F

#ifndef STRUCTS
#define STRUCTS

struct Axes {
    float x;
    float y;
    float z;
};

struct Axes_long {
    long x;
    long y;
    long z;
};

struct RF_data {
  byte thrust;
  byte x;
  byte y;
  byte rot;
  byte data;
};

#endif 

class Mag {
  public:
    //FUNCTIONS
    void MG_init();
    void MG_Callibrate();
    float MG_Get_Direction(Axes Gyro_value);

  private:
    //FUNCTIONS
    void MG_Write(byte reg, byte value);
    byte MG_Read(byte reg);
    void MG_Set_Gain(float gain);
    Axes_long MG_Get_Data();

    //VARIABLES
    //Callibrate Data
    static int Mag_Callibrate;
    //Data
    static Axes MG_value;
};

#endif
