#include "Motors.h"

unsigned long Motors::previos_time = 0;

void Motors::MO_init() {
  Serial.println("Motor Init");
  
  pinMode(MOTOR_NORTH, OUTPUT);
  pinMode(MOTOR_SOUTH, OUTPUT);
  pinMode(MOTOR_EAST, OUTPUT);
  pinMode(MOTOR_WEST, OUTPUT);
  pinMode(LED_BUILTIN, OUTPUT);

  previos_time = micros();
  
  Serial.println("  Low");
  for(int i = 0; i < 100; i++){
    MO_Set(0,0,0,0);
  }
  Serial.println("  High");
  for(int i = 0; i < 200; i++){
    MO_Set(100,100,100,100);
  }
  Serial.println("  Low");
  for(int i = 0; i < 700; i++){
    MO_Set(0,0,0,0);
  }
}

void Motors::MO_Set(int input_north, int input_south, int input_east, int input_west) {
  
  int input_order[4] = {north, south, east, west};
  int input_value[4] = {input_north, input_south, input_east, input_west};
  
    for(int i = 0; i < 4; i++) {
      for(int j = 0; j < 4; j++) {
        if(input_value[i] > input_value[j]){
           int higher_value = input_value[j];
           int lover_value = input_value[i];
           int higher_order = input_order[j];
           int lower_order = input_order[i];
           input_value[i] = higher_value;
           input_value[j] = lover_value;
           input_order[i] = higher_order;
           input_order[j] = lower_order;
        }
      }
    }
 
  unsigned long current_time = micros();
  if(current_time - previos_time > 4000) {
    Serial.println("ERROR: Loop time too long");
    while(1);
  }
  
  while(current_time - previos_time < 4000) {
    current_time = micros();
  }

  pin_write(north, true);
  pin_write(south, true);
  pin_write(east, true);
  pin_write(west, true);
  delayMicroseconds(1000);
  delayMicroseconds(input_value[3]);
  pin_write(input_order[3], false);
  delayMicroseconds(input_value[2] - input_value[3]);
  pin_write(input_order[2], false);
  delayMicroseconds(input_value[1] - input_value[2]);
  pin_write(input_order[1], false);
  delayMicroseconds(input_value[0] - input_value[1]);
  pin_write(input_order[0], false);
  delayMicroseconds(1000 - input_value[0]);

  previos_time = micros();

}

void Motors::pin_write(int motor, bool enable) {
  
  if(enable == true) {
    if(motor == north) {
        digitalWrite(MOTOR_NORTH, HIGH);
    } else if(motor == south) {
        digitalWrite(MOTOR_SOUTH, HIGH);
    } else if(motor == east) {
        digitalWrite(MOTOR_EAST, HIGH);
    } else if(motor == west) {
        digitalWrite(MOTOR_WEST, HIGH);
    }
  } else {
    if(motor == north) {
        digitalWrite(MOTOR_NORTH, LOW);
    } else if(motor == south) {
        digitalWrite(MOTOR_SOUTH, LOW);
    } else if(motor == east) {
        digitalWrite(MOTOR_EAST, LOW);
    } else if(motor == west) {
        digitalWrite(MOTOR_WEST, LOW);
    }
  }
}

