#include "PID.h"

Axes PID::PIDpraportional = {0,0,0};
Axes PID::PIDintegral = {0,0,0};
Axes PID::PIDdifferential = {0,0,0};
Axes PID::PIDerror = {0,0,0};
Axes PID::PIDpreverror = {0,0,0};

Axes PID::Conversion(Axes input, Axes desire, float proportional, float differential, float integral) {
  
  Axes output;
  
  PIDerror.x = input.x - desire.x;
  PIDerror.y = input.y - desire.y;

  //PRAPORTIONAL
  PIDpraportional.x = PIDerror.x * proportional;
  PIDpraportional.y = PIDerror.y * proportional;
  
  //INTEGRAL

  float Max_Integral = 30;
  
  if(PIDintegral.x <= Max_Integral  && PIDintegral.x >= -Max_Integral) {
    PIDintegral.x += PIDerror.x * integral;
  } else if (PIDintegral.x > Max_Integral) {
    PIDintegral.x = Max_Integral;
  } else {
    PIDintegral.x = -Max_Integral;
  }
  if(PIDintegral.y <= Max_Integral  && PIDintegral.y >= -Max_Integral) {
    PIDintegral.y += PIDerror.y * integral;
  } else if (PIDintegral.y > Max_Integral) {
    PIDintegral.y = Max_Integral;
  } else {
    PIDintegral.y = -Max_Integral;
  }

  //Serial.println(PIDintegral.y);

  //DIFFERENTIAL
  PIDdifferential.x = ((PIDerror.x - PIDpreverror.x) / 0.01) * differential;
  PIDdifferential.y = ((PIDerror.y - PIDpreverror.y) / 0.01) * differential;
  
  output.x = PIDpraportional.x + PIDintegral.x + PIDdifferential.x;
  output.y = PIDpraportional.y + PIDintegral.y + PIDdifferential.y;
  output.z = 0;

  PIDpreverror.x = PIDerror.x;
  PIDpreverror.y = PIDerror.y;
  
  return {output.x,output.y,output.z};
}

