#ifndef PID_
#define PID_

#include <SPI.h>

/*
 * Best so far: Kp = 0.3, Ki = 0.01, Kd = 0.018
 * 
 */

#define PRAPORTIONAL_CONSTANT 3 //5
#define INTEGRAL_CONSTANT 0.01 //0.08
#define DIFFERENTIAL_CONSTANT 0 //0.25//0.33

#define GYRO_REFRESH_RATE 100

#ifndef STRUCTS
#define STRUCTS

struct Axes {
    float x;
    float y;
    float z;
};

struct Axes_long {
    long x;
    long y;
    long z;
};

struct RF_data {
  byte thrust;
  byte x;
  byte y;
  byte rot;
  byte data;
};

#endif 

class PID {
  public:
    Axes Conversion(Axes input, Axes desire, float ku, float tu, float integral);

  private:
    static Axes PIDpraportional;
    static Axes PIDintegral;
    static Axes PIDdifferential;
    static Axes PIDerror;
    static Axes PIDpreverror;
  
};

#endif
